searchData={"items":[{"type":"module","title":"BoldTranscriptsEx","doc":"","ref":"BoldTranscriptsEx.html"},{"type":"function","title":"BoldTranscriptsEx.test/0","doc":"","ref":"BoldTranscriptsEx.html#test/0"},{"type":"module","title":"BoldTranscriptsEx.Convert","doc":"","ref":"BoldTranscriptsEx.Convert.html"},{"type":"function","title":"BoldTranscriptsEx.Convert.chapters_to_webvtt/3","doc":"","ref":"BoldTranscriptsEx.Convert.html#chapters_to_webvtt/3"},{"type":"function","title":"BoldTranscriptsEx.Convert.chapters_webvtt_to_text/1","doc":"Converts a chapters WebVTT file to a text with one chapter per line and a short timestamp.","ref":"BoldTranscriptsEx.Convert.html#chapters_webvtt_to_text/1"},{"type":"function","title":"Example - BoldTranscriptsEx.Convert.chapters_webvtt_to_text/1","doc":"iex> Convert.chapters_webvtt_to_text(\"\"\"\n    ...> WEBVTT\n    ...>\n    ...> 1\n    ...> 00:00:00.000 --> 00:00:37.000\n    ...> Hello World\n    ...>\n    ...> 2\n    ...> 00:00:37.000 --> 00:01:59.000\n    ...> Introduction\n    ...> \"\"\")\n    \"00:00 Hello World\\n00:37 Introduction\"","ref":"BoldTranscriptsEx.Convert.html#chapters_webvtt_to_text/1-example"},{"type":"function","title":"BoldTranscriptsEx.Convert.from/3","doc":"Converts a transcript from a specific service to Bold format.","ref":"BoldTranscriptsEx.Convert.html#from/3"},{"type":"function","title":"Parameters - BoldTranscriptsEx.Convert.from/3","doc":"- `service`: The service that generated the transcript (e.g., `:assemblyai`, `:deepgram`)\n- `transcript_data`: The JSON string or decoded map of the transcript data\n- `opts`: Options for the conversion:\n  - `:language`: (required for Deepgram) The language code of the transcript (e.g., \"en\", \"lt\")\n  - Other service-specific options","ref":"BoldTranscriptsEx.Convert.html#from/3-parameters"},{"type":"function","title":"Returns - BoldTranscriptsEx.Convert.from/3","doc":"- `{:ok, data}`: A tuple with `:ok` atom and the data in Bold Transcript format\n- `{:error, reason}`: If the conversion fails or required options are missing","ref":"BoldTranscriptsEx.Convert.html#from/3-returns"},{"type":"function","title":"BoldTranscriptsEx.Convert.text_to_chapters_webvtt/2","doc":"Converts a text with one chapter per row into a WebVTT file.","ref":"BoldTranscriptsEx.Convert.html#text_to_chapters_webvtt/2"},{"type":"function","title":"Example - BoldTranscriptsEx.Convert.text_to_chapters_webvtt/2","doc":"iex> Convert.text_to_chapters_webvtt(\"\"\"\n    ...> 00:00 Hello World\n    ...> 01:59 The End\n    ...> \"\"\", 155)\n    \"WEBVTT\\n\\n1\\n00:00:00.000 --> 00:01:59.000\\nHello World\\n\\n2\\n00:01:59.000 --> 00:02:35.000\\nThe End\\n\\n\"","ref":"BoldTranscriptsEx.Convert.html#text_to_chapters_webvtt/2-example"},{"type":"module","title":"BoldTranscriptsEx.Convert.AssemblyAI","doc":"Handles conversion of AssemblyAI transcription files to Bold format.","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html"},{"type":"function","title":"BoldTranscriptsEx.Convert.AssemblyAI.chapters_to_webvtt/2","doc":"Converts chapter data extracted from an AssemblyAI transcript JSON to WebVTT format.","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#chapters_to_webvtt/2"},{"type":"function","title":"Parameters - BoldTranscriptsEx.Convert.AssemblyAI.chapters_to_webvtt/2","doc":"- `transcript_json`: The JSON string of the full transcript data from AssemblyAI, which includes chapters.\n- `opts`: Optional parameters for the conversion (unused for now, but included for future flexibility).","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#chapters_to_webvtt/2-parameters"},{"type":"function","title":"Returns - BoldTranscriptsEx.Convert.AssemblyAI.chapters_to_webvtt/2","doc":"- A string in WebVTT format representing the chapters.","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#chapters_to_webvtt/2-returns"},{"type":"function","title":"Examples - BoldTranscriptsEx.Convert.AssemblyAI.chapters_to_webvtt/2","doc":"iex> transcript_json = \"{...}\" # Your full transcript JSON string here\n    iex> BoldTranscriptsEx.Convert.AssemblyAI.chapters_to_webvtt(transcript_json)\n    \"WEBVTT\n\n1\n00:00:01.000 --> 00:00:05.000\nChapter 1\n\nSummary of chapter 1\n\n\"","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#chapters_to_webvtt/2-examples"},{"type":"function","title":"BoldTranscriptsEx.Convert.AssemblyAI.transcript_to_bold/2","doc":"Converts an AssemblyAI transcript to the Bold Transcript format.","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#transcript_to_bold/2"},{"type":"function","title":"Parameters - BoldTranscriptsEx.Convert.AssemblyAI.transcript_to_bold/2","doc":"- `main_transcript`: The JSON string of the main transcript data from AssemblyAI.\n- `opts`: Options for the conversion. Can include `:paragraphs` and `:sentences` data as JSON strings.","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#transcript_to_bold/2-parameters"},{"type":"function","title":"Returns - BoldTranscriptsEx.Convert.AssemblyAI.transcript_to_bold/2","doc":"- `{:ok, merged_data}`: A tuple with `:ok` atom and the merged data in Bold Transcript format.","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#transcript_to_bold/2-returns"},{"type":"function","title":"Examples - BoldTranscriptsEx.Convert.AssemblyAI.transcript_to_bold/2","doc":"iex> BoldTranscriptsEx.Convert.AssemblyAI.transcript_to_bold(main_transcript)\n    {:ok, %{\"metadata\" => metadata, \"utterances\" => utterances, \"paragraphs\" => paragraphs}}","ref":"BoldTranscriptsEx.Convert.AssemblyAI.html#transcript_to_bold/2-examples"},{"type":"module","title":"BoldTranscriptsEx.Convert.Common","doc":"Conversion functions that are common to all providers.","ref":"BoldTranscriptsEx.Convert.Common.html"},{"type":"function","title":"BoldTranscriptsEx.Convert.Common.chapters_webvtt_to_text/1","doc":"Converts a chapters WebVTT into a text with one chapter and timestamp per line.","ref":"BoldTranscriptsEx.Convert.Common.html#chapters_webvtt_to_text/1"},{"type":"function","title":"BoldTranscriptsEx.Convert.Common.text_to_chapters_webvtt/2","doc":"Converts a text input to a chapters WebVTT text.\n\nExpects the input text and a total duration in Seconds.","ref":"BoldTranscriptsEx.Convert.Common.html#text_to_chapters_webvtt/2"},{"type":"module","title":"BoldTranscriptsEx.Convert.Deepgram","doc":"Handles conversion of Deepgram transcription files to Bold format.","ref":"BoldTranscriptsEx.Convert.Deepgram.html"},{"type":"function","title":"BoldTranscriptsEx.Convert.Deepgram.transcript_to_bold/2","doc":"Converts a Deepgram transcript to the Bold Transcript format.","ref":"BoldTranscriptsEx.Convert.Deepgram.html#transcript_to_bold/2"},{"type":"function","title":"Parameters - BoldTranscriptsEx.Convert.Deepgram.transcript_to_bold/2","doc":"- `transcript`: The JSON string or decoded map of the transcript data from Deepgram.\n- `opts`: Options for the conversion:\n  - `:language`: (required) The language code of the transcript (e.g., \"en\", \"lt\")","ref":"BoldTranscriptsEx.Convert.Deepgram.html#transcript_to_bold/2-parameters"},{"type":"function","title":"Returns - BoldTranscriptsEx.Convert.Deepgram.transcript_to_bold/2","doc":"- `{:ok, merged_data}`: A tuple with `:ok` atom and the data in Bold Transcript format.\n- `{:error, reason}`: If required options are missing.","ref":"BoldTranscriptsEx.Convert.Deepgram.html#transcript_to_bold/2-returns"},{"type":"function","title":"Examples - BoldTranscriptsEx.Convert.Deepgram.transcript_to_bold/2","doc":"iex> BoldTranscriptsEx.Convert.Deepgram.transcript_to_bold(transcript, language: \"lt\")\n    {:ok, %{\"metadata\" => metadata, \"utterances\" => utterances, \"paragraphs\" => paragraphs}}","ref":"BoldTranscriptsEx.Convert.Deepgram.html#transcript_to_bold/2-examples"},{"type":"module","title":"BoldTranscriptsEx.Utils","doc":"","ref":"BoldTranscriptsEx.Utils.html"},{"type":"function","title":"BoldTranscriptsEx.Utils.format_chapter_timestamp/2","doc":"Formats a duration from millisecond or seconds to a chapter timestamp like `01:12:34.000`\nwith `HH:MM:SS.000` format (hour, minutes, seconds).\n\nThe second parameter indicates whether the given number is in milliseconds or seconds.","ref":"BoldTranscriptsEx.Utils.html#format_chapter_timestamp/2"},{"type":"function","title":"BoldTranscriptsEx.Utils.maybe_decode/1","doc":"Decodes a binary into json if necessary.","ref":"BoldTranscriptsEx.Utils.html#maybe_decode/1"},{"type":"function","title":"BoldTranscriptsEx.Utils.pad/2","doc":"","ref":"BoldTranscriptsEx.Utils.html#pad/2"},{"type":"module","title":"BoldTranscriptsEx.WebVTT","doc":"Provides functionality for parsing WebVTT chapter information.\n\nThis module is designed to extract chapter information from WebVTT files,\nwhich are typically used for subtitles or chapter markers in video content.","ref":"BoldTranscriptsEx.WebVTT.html"},{"type":"function","title":"BoldTranscriptsEx.WebVTT.chapters_to_webvtt/1","doc":"","ref":"BoldTranscriptsEx.WebVTT.html#chapters_to_webvtt/1"},{"type":"function","title":"BoldTranscriptsEx.WebVTT.parse_chapters/1","doc":"Parses WebVTT content to extract chapters, converting them into a structured list.\n\nEach item in the returned list represents a chapter with its start time and title.","ref":"BoldTranscriptsEx.WebVTT.html#parse_chapters/1"},{"type":"function","title":"Parameters - BoldTranscriptsEx.WebVTT.parse_chapters/1","doc":"- `webvtt`: The WebVTT content as a string.","ref":"BoldTranscriptsEx.WebVTT.html#parse_chapters/1-parameters"},{"type":"function","title":"Returns - BoldTranscriptsEx.WebVTT.parse_chapters/1","doc":"A list of maps, each containing `:start` and `:title` keys for a chapter.","ref":"BoldTranscriptsEx.WebVTT.html#parse_chapters/1-returns"},{"type":"function","title":"Examples - BoldTranscriptsEx.WebVTT.parse_chapters/1","doc":"iex> webvtt_content = \"WEBVTT\\n\\n1\\n00:00:03.000 --> 00:00:16.000\\nComing soon: Back to Stanford\"\n    iex> BoldTranscriptsEx.WebVTT.parse_chapters(webvtt_content)\n    [%{start: \"0:03\", end: \"0:16\", title: \"Coming soon: Back to Stanford\"}]","ref":"BoldTranscriptsEx.WebVTT.html#parse_chapters/1-examples"},{"type":"module","title":"BoldTranscriptsEx.WebVTT2","doc":"","ref":"BoldTranscriptsEx.WebVTT2.html"},{"type":"function","title":"BoldTranscriptsEx.WebVTT2.create/1","doc":"","ref":"BoldTranscriptsEx.WebVTT2.html#create/1"},{"type":"function","title":"BoldTranscriptsEx.WebVTT2.process_line/1","doc":"","ref":"BoldTranscriptsEx.WebVTT2.html#process_line/1"},{"type":"extras","title":"BoldTranscriptsEx","doc":"# BoldTranscriptsEx\n\nA library for converting transcripts from various speech-to-text providers into Bold's unified transcript format. Currently supports:\n\n- AssemblyAI transcripts (including paragraphs, sentences, and chapters)\n- Deepgram transcripts (with speaker diarization support)","ref":"readme.html"},{"type":"extras","title":"Installation - BoldTranscriptsEx","doc":"Add `bold_transcripts_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:bold_transcripts_ex, \"~> 0.4.2\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - BoldTranscriptsEx","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Converting AssemblyAI Transcripts - BoldTranscriptsEx","doc":"```elixir\n# Basic conversion\n{:ok, bold_transcript} = BoldTranscriptsEx.Convert.from(:assemblyai, transcript_json)\n\n# With paragraphs and sentences data\n{:ok, bold_transcript} = BoldTranscriptsEx.Convert.from(:assemblyai, transcript_json,\n  paragraphs: paragraphs_json,\n  sentences: sentences_json\n)\n\n# Converting chapters to WebVTT\n{:ok, webvtt} = BoldTranscriptsEx.Convert.chapters_to_webvtt(:assemblyai, transcript_json)\n```","ref":"readme.html#converting-assemblyai-transcripts"},{"type":"extras","title":"Converting Deepgram Transcripts - BoldTranscriptsEx","doc":"```elixir\n# Language parameter is required for Deepgram\n{:ok, bold_transcript} = BoldTranscriptsEx.Convert.from(:deepgram, transcript_json,\n  language: \"en\"\n)\n```","ref":"readme.html#converting-deepgram-transcripts"},{"type":"extras","title":"Output Format - BoldTranscriptsEx","doc":"The converted transcript follows Bold's unified format:\n\n```elixir\n%{\n  \"metadata\" => %{\n    \"duration\" => float(),      # Duration in seconds\n    \"language\" => string(),     # Language code\n    \"source_url\" => string(),   # Original audio URL\n    \"speakers\" => [string()]    # List of speaker identifiers\n  },\n  \"utterances\" => [            # List of speech segments\n    %{\n      \"start\" => float(),      # Start time in seconds\n      \"end\" => float(),        # End time in seconds\n      \"text\" => string(),      # Transcribed text\n      \"confidence\" => float(), # Confidence score\n      \"speaker\" => string()    # Speaker identifier\n    }\n  ],\n  \"paragraphs\" => [           # List of paragraphs (AssemblyAI only)\n    %{\n      \"start\" => float(),     # Start time in seconds\n      \"end\" => float(),       # End time in seconds\n      \"sentences\" => [        # List of sentences in paragraph\n        %{\n          \"start\" => float(),\n          \"end\" => float(),\n          \"text\" => string()\n        }\n      ]\n    }\n  ]\n}\n```","ref":"readme.html#output-format"},{"type":"extras","title":"License - BoldTranscriptsEx","doc":"This project is licensed under the MIT License.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}